'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var stormplayer = require('@stormstreaming/stormplayer');
var react = require('react');
var jsxRuntime = require('react/jsx-runtime');

function _typeof(obj) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, _typeof(obj);
}

function _toPrimitive(input, hint) {
  if (_typeof(input) !== "object" || input === null) return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== undefined) {
    var res = prim.call(input, hint || "default");
    if (_typeof(res) !== "object") return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}

function _toPropertyKey(arg) {
  var key = _toPrimitive(arg, "string");
  return _typeof(key) === "symbol" ? key : String(key);
}

function _defineProperty(obj, key, value) {
  key = _toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

var CONTAINER_ID = "reactStormPlayer-{{id}}";

var dec2hex = function dec2hex(dec) {
  return dec.toString(16).padStart(2, "0");
};

// generateId :: Integer -> String
var generateRandomId = function generateRandomId(length) {
  var arr = new Uint8Array((length || 40) / 2);
  window.crypto.getRandomValues(arr);
  return Array.from(arr, dec2hex).join("");
};

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var StormPlayer = /*#__PURE__*/react.forwardRef(function (_ref, ref) {
  var playerConfig = _ref.playerConfig,
    streamConfig = _ref.streamConfig;
  var playerRef = react.useRef(null);
  var containerRef = react.useRef(null);
  var isRendered = react.useRef(false);
  react.useEffect(function () {
    if (!isRendered.current && containerRef.current) {
      var _containerRef$current;
      var newContainerId = CONTAINER_ID.replace("{{id}}", generateRandomId());
      (_containerRef$current = containerRef.current) === null || _containerRef$current === void 0 ? void 0 : _containerRef$current.setAttribute("id", newContainerId);
      var instance = new stormplayer.StormPlayer(_objectSpread(_objectSpread({}, playerConfig), {}, {
        containerID: newContainerId
      }), streamConfig);
      playerRef.current = instance;
      if (ref) {
        if (typeof ref === "function") {
          ref(instance);
        } else if (ref) {
          ref.current = instance;
        }
      }
    }
    isRendered.current = true;
    return function () {
      var _playerRef$current;
      (_playerRef$current = playerRef.current) === null || _playerRef$current === void 0 ? void 0 : _playerRef$current.destroy();
    };
  }, []);
  react.useEffect(function () {
    if (isRendered.current) {
      var _playerRef$current2, _playerRef$current3;
      (_playerRef$current2 = playerRef.current) === null || _playerRef$current2 === void 0 ? void 0 : _playerRef$current2.setPlayerConfig(_objectSpread(_objectSpread({}, playerConfig), {}, {
        containerID: (_playerRef$current3 = playerRef.current) === null || _playerRef$current3 === void 0 ? void 0 : _playerRef$current3.getRawPlayerConfig().containerID
      }));
    }
  }, [JSON.stringify(playerConfig)]);
  react.useEffect(function () {
    if (isRendered.current) {
      var _playerRef$current4;
      (_playerRef$current4 = playerRef.current) === null || _playerRef$current4 === void 0 ? void 0 : _playerRef$current4.setStreamConfig(streamConfig);
    }
  }, [JSON.stringify(streamConfig)]);
  return /*#__PURE__*/jsxRuntime.jsx("div", {
    ref: containerRef
  });
});

Object.defineProperty(exports, 'StormPlayerClass', {
  enumerable: true,
  get: function () { return stormplayer.StormPlayer; }
});
exports.StormPlayer = StormPlayer;
